/*
Edité avec le créateur de plugin MuseScore3
Michel Come (2019/2020)
Accordéon diatonique Sol/Do 21 touches sur deux rangées.
Version 1: A, a, Aa
Version 2: Corrections sur Ré 69 et La 74
Version 3: Sélection multiple et plusieurs diatos
*/

import QtQuick 2.0
import MuseScore 3.0
MuseScore 
{
version: "3.3.4"
description: "Personaliser une tablature d'accordéon diatonique Sol/Do"
menuPath: "Plugins.Personnaliser la tablature (V3)"

// Faire un curseur à la position (en ticks MIDI)
function riouagne(position)
{
var Crs = curScore.newCursor();
Crs.rewind(0) ;
while ( Crs.segment.tick < position ){ Crs.next();}
return Crs ;
}

      onRun:         
      {  
      if (typeof curScore === 'undefined')Qt.quit();
      var Select = curScore.selection.elements;
            for (var Indic = 0; Indic < Select.length ; Indic ++) 
            {
            if (Select[Indic].type == Element.STAFF_TEXT)
                  {
                  if ( Select[Indic].offsetY > 11 )
                        {
                        // L'élément sélectionné est un accord 
                        switch (Select[Indic].text)
                              {
                              case "A": Select[Indic].text = "a" ; break ;
                              case "C": Select[Indic].text = "c" ; break ;
                              case "D": Select[Indic].text = "d" ; break ;
                              case "E": Select[Indic].text = "e" ; break ;
                              case "F": Select[Indic].text = "f" ; break ;
                              case "G": Select[Indic].text = "g" ; break ;
                              case "a": Select[Indic].text = "Aa" ; break ;
                              case "c": Select[Indic].text = "Cc" ; break ;
                              case "d": Select[Indic].text = "Dd" ; break ;
                              case "e": Select[Indic].text = "Ee" ; break ;
                              case "f": Select[Indic].text = "Ff" ; break ;
                              case "g": Select[Indic].text = "Gg" ; break ;
                              case "Aa": Select[Indic].text = "A" ; break ;
                              case "Cc": Select[Indic].text = "C" ; break ;
                              case "Dd": Select[Indic].text = "D" ; break ;
                              case "Ee": Select[Indic].text = "E" ; break ;
                              case "Ff": Select[Indic].text = "F" ; break ;
                              case "Gg": Select[Indic].text = "G" ; break ;
                              }
                        } // Accord sélectionné
                  else if (Select[Indic].offsetY > 5)  // L'élément sélectionné est un numéro de touche
                        {
                        var Numero = Select[Indic].text;
                        var Sens = Select[Indic].offsetY ;
                        var PT = "P" ; // par défaut
                        if (Sens < 8) {PT = "P"} else {PT = "T"}
                        var NumPT = Numero + PT ;
                        switch (NumPT)
                              {
                              case "1'P": Select[Indic].text = "1" ; Select[Indic].offsetY = 2.5 ; break ;  //52 Mi
                              case "1T": Select[Indic].text = "1'" ; Select[Indic].offsetY = -2.5 ; break ; //52 Mi
                              case "4P": Select[Indic].text = "2'" ; Select[Indic].offsetY = 2.5; break ;   //59 Si
                              case "2'T": Select[Indic].text = "4" ; Select[Indic].offsetY = -2.5 ; break ; //59 Si
                              case "3'P": Select[Indic].text = "4" ; Select[Indic].offsetY = 2.5 ; break ;  //60 Do
                              case "4T": Select[Indic].text = "3'" ; Select[Indic].offsetY = -2.5 ; break ; //60 Do
                              case "5P": Select[Indic].text = "3'" ; Select[Indic].offsetY = 2.5 ; break ;  //62 Ré
                              case "3'T": Select[Indic].text = "5" ; Select[Indic].offsetY = -2.5 ; break ; //62 Ré
                              case "4'P": Select[Indic].text = "5" ; Select[Indic].offsetY = 2.5 ; break ;  //64 Mi
                              case "5T": Select[Indic].text = "4'" ; Select[Indic].offsetY = -2.5 ; break ; //64 Mi
                              case "6P": Select[Indic].text = "5'" ; break ;                             //67 Sol
                              case "5'P": Select[Indic].text = "6" ; break ;                             //67 Sol
                              case "7T": Select[Indic].text = "5'" ; break ;                             //69 La
                              case "5'T": Select[Indic].text = "7" ; break ;                             //69 La
                              case "7P": Select[Indic].text = "6'" ; Select[Indic].offsetY = 2.5 ; break ;  //71 Si
                              case "6'T": Select[Indic].text = "7" ; Select[Indic].offsetY = -2.5 ; break ; //71 Si
                              case "6'P": Select[Indic].text = "8" ; Select[Indic].offsetY = 2.5 ; break ;  //72 Do
                              case "8T": Select[Indic].text = "6'" ; Select[Indic].offsetY = -2.5 ; break ; //72 Do
                              case "8P": Select[Indic].text = "7'" ; Select[Indic].offsetY = 2.5 ; break ;  //74 Ré
                              case "7'T": Select[Indic].text = "8" ; Select[Indic].offsetY = -2.5 ; break ; //74 Ré
                              case "7'P": Select[Indic].text = "9" ; Select[Indic].offsetY = 2.5 ; break ;  //76 Mi
                              case "9T": Select[Indic].text = "7'" ; Select[Indic].offsetY = -2.5 ; break ; //76 Mi
                              case "8'P": Select[Indic].text = "9" ; break ;                             //79 Sol
                              case "9P": Select[Indic].text = "8'" ; break ;                             //79 Sol
                              case "11T": Select[Indic].text = "9'" ; break ;                            //81 La
                              case "9'T": Select[Indic].text = "11" ; break ;                            //81 La
                              case "10P": Select[Indic].text = "10'" ; Select[Indic].offsetY = 2.5 ; break ;//83 Si
                              case "10'T": Select[Indic].text = "10" ; Select[Indic].offsetY = -2.5 ; break;//83 Si
                              }
                        //Sens = Select[Indic].offsetY ;
                        //if (Sens == 6) {PT = "P"} else {PT = "T"}            
                        } // Lettre d'accord / Numéro de touche 
                               
                  // mettre le curseur sur l'élément sélectionné
                  var Select0 = Select[Indic].parent;
                  if ( Select0.type == Element.CHORD ){var Pointeur = Select0.parent.tick;}
                  if ( Select0.type == Element.SEGMENT ){var Pointeur = Select0.tick;}
                  var Curseur = riouagne(Pointeur) ; // rewind(1) ça marche pas !

                  for (var Chaque = 0; Chaque < Curseur.segment.annotations.length ; Chaque ++)
                        {
                        var Ac = " " ;
                        var PT = " " ;
                        var ChaquAnnot = Curseur.segment.annotations[Chaque];
                        if (ChaquAnnot.type == Element.STAFF_TEXT )
                              {
                              Sens = ChaquAnnot.offsetY ;
                              if ( Sens > 11)
                                    {
                                    // Le texte de portée est un accord
                                    Ac = ChaquAnnot.text ;
                                    // Le texte de portée précédent est il un numéro de touche ?
                                    var Precedent = Curseur.segment.annotations[Chaque - 1];
                                    if (Precedent.offsetY < 8) {PT = "P"} else {PT = "T"}
                                    
                                    // Remplacement de la lettre d'accord            
                                    var AcPT = Ac + PT
                                    switch (AcPT)
                                          {
                                          // Résolution de conflit accord/sens
                                          case "AP": ChaquAnnot.text = "E";   break ;
                                          case "CT": ChaquAnnot.text = "G";   break ;
                                          case "DP": ChaquAnnot.text = "G";   break ;
                                          case "ET": ChaquAnnot.text = "A";   break ;
                                          case "GT": ChaquAnnot.text = "D";   break ;
                                          case "GP": ChaquAnnot.text = "C";   break ;
                                          case "aP": ChaquAnnot.text = "e";   break ;
                                          case "cT": ChaquAnnot.text = "g";   break ;
                                          case "dP": ChaquAnnot.text = "g";   break ;
                                          case "eT": ChaquAnnot.text = "a";   break ;
                                          case "gT": ChaquAnnot.text = "d";   break ;
                                          case "gP": ChaquAnnot.text = "c";   break ;
                                          case "AaP": ChaquAnnot.text = "Ee";   break ;
                                          case "CcT": ChaquAnnot.text = "Gg";   break ;
                                          case "DdP": ChaquAnnot.text = "Gg";   break ;
                                          case "EeT": ChaquAnnot.text = "Aa";   break ;
                                          case "GgT": ChaquAnnot.text = "Dd";   break ;
                                          case "GgP": ChaquAnnot.text = "Cc";   break ;
                                          } // résolution de conflit
                                    } // Sens > 11 (Accord)
                              } // Texte
                        } // Chaque annotation	      		
                  } // texte de portée
            } // Indic : Chaque élément sélectionné
      Qt.quit();
      }     // Run
}     // MuseScore
